//  Stack
//       

#include <stdio.h>
#include <string.h>

const int MAX_SIZE = 1000;	//   

class Stack
{
	char *top, *bottom;		//      
	int length;				//  
public:
	Stack (int n);			//  
	
	char push (char c)
	{						//   
		if (top<bottom+length)
			*top++ = c;
		return c;
	}
	
	char pop()
	{						//   
		char c = top>bottom ? *--top : 0;
		return c;
	}
	
	~Stack () { delete [] bottom; }	// 
};

Stack::Stack(int n) 				//  
{
	if (0 < n && n < MAX_SIZE)
	{
		length = n;
		top=bottom=new char [n];	//   
		memset(top,0,n);
	}
	else
	{
		top=bottom=NULL;			//  
		length = 0;
	}
}

void reverse (char *s) 				//  
{
	Stack stack(strlen(s));			//  
	char *p;						//  
	
	for (p=s; *p; p++)				//    
		stack.push(*p);
	for (p=s; *p=stack.pop(); p++)	//    
		;
}

void main()							//  
{
	char buff [MAX_SIZE +1], c;		//  
	int i=1;						//  
	
	while (i) 						//    ()
	{
		puts("\n\n Enter a string");
		for (i=0; (c=getc(stdin)) != '\n' && i<MAX_SIZE ; i++)
			buff[i] = c;
		buff[i] = '\0';
		if (i)
		{
			reverse(buff);
			printf ("\n The reversed string:\n\n%s",buff);
		}
	}
}
